> ## Class BirtMath

> The BirtMath class provides functions to manipulate numeric data, for example, to add, subtract, multiple, divide, and round numbers. A number is a generic object that can be cast as another type in the Data Type field of the Edit Data Binding dialog. This class is static. The application cannot create instances of the class.

> ### BirtMath.add

> This function returns the sum of two numbers.

> Syntax

> Number BirtMath.add( Number n1, Number n2 )

> Parameters

> n1

> Number object. The first number to use in the calculation.

> n2

> The second number to use in the calculation.

> Returns

> Number object. The number that results from adding n1 and n2.

> Example

> The following example returns the sum of values in the SalesTotal and Shipping fields:

> BirtMath.add( row["SalesTotal"], row["Shipping"] )

> ### BirtMath.ceiling

> This function rounds a number up, away from 0, to the nearest specified multiple.

> Syntax

> Number BirtMath.ceiling( Number n, Number significance )

> Parameters

> n

> Number object. The number to round up.

> significance

> Number object. The multiple to round n to.

> Returns

> Number object. A number that results from the rounding. If n is an exact multiple of significance, no rounding occurs.

> Examples

> BirtMath.ceiling( ) is commonly used to round up prices. For example, to avoid dealing with pennies, you can round prices in a Price field up to the nearest nickel with the following expression:

> BirtMath.ceiling( row["Price"] , 0.05 )

> If the Price value is 20.52, the expression returns 20.55.

> The following expression rounds prices up to the nearest dime:

> BirtMath.ceiling( row["Price"] , 0.1 )

> If the Price value is 20.52, the expression returns 20.60. If the Price value is 20.40, the expression returns 20.40. No rounding occurs because 20.40 is a multiple of 0.1.

> The following expression rounds prices up to the nearest dollar:

> BirtMath.ceiling( row["Price"] , 1 )

> If the Price value is 20.30, the expression returns 21.

> ### BirtMath.divide

> This function returns the result of dividing one number by another.

> Syntax

> Number BirtMath.divide( Number dividend, Number divisor )

> Parameters

> dividend

> Number object. The number to be divided.

> divisor

> Number object. The number by which dividend is divided.

> Returns

> Number object. A number that results from dividing dividend by divisor.

> Examples

> The following example shows the results of dividing specific numbers:

> BirtMath.divide( 10, 2 ) // returns 5
> BirtMath.divide( 2, 10) // returns 0.2

> The following example returns the result of dividing values in the Total field by values in the Quantity field:

> BirtMath.divide( row["Total"], row["Quantity"] )

> ### BirtMath.mod

> This function returns the remainder after a number is divided by a divisor.

> Syntax

> Number BirtMath.mod( Number number, Number divisor )

> Parameters

> number

> Number object. The number to be divided.

> divisor

> Number object. The number by which the first number is divided. You must specify a non-zero number.

> Returns

> The remainder after number is divided by divisor.

> Examples

> The following examples shows the results that the function returns for specific numbers:

> BirtMath.mod( 10, 3 ) // returns 1
> BirtMath.mod( 10, 5 ) // returns 0
> BirtMath.mod( 10, 6 ) // returns 4

> The following example checks if numbers in the Grade field are odd or even. When the divisor is 2, the function returns 0 for even numbers, and 1 for odd numbers.

> BirtMath.mod( row["Grade"], 2 )

> ### BirtMath.multiply

> This function returns the multiplication of two numbers.

> Syntax

> Number BirtMath.multiply( Number n1, Number n2 )

> Parameters

> n1

> Number object. The first number to use in the calculation.

> n2

> Number object. The second number to use in the calculation.

> Returns

> Number object. A number that results from multiplying n1 and n2.

> Example

> The following example returns the result of multiplying values in the QuantityOrdered and PriceEach fields:

> BirtMath.multiply( row["QuantityOrdered"], row["PriceEach"] )

> ### BirtMath.round

> This function rounds a number to a specified number of digits.

> Syntax

> Number BirtMath.round( Number number, Number dec )

> Parameters

> number

> Number object. The number to round.

> dec

> Number object. The number of digits to round number to. If you omit this argument, the function assumes 0.

> Returns

> Number object. A number rounded to a specified number of digits.

> Examples

> The following examples shows the results that the function returns for specific numbers:

> BirtMath.round( 1545.50 ) // returns 1546
> BirtMath.round( 1545.56, 1 ) // returns 1545.6
> BirtMath.round( 1545.23, 1 ) // returns 1545.2
> BirtMath.round( 1545.50, -1 ) // returns 1550

> The following example rounds the values in the PriceEstimate field to return an integer:

> BirtMath.round( row["PriceEstimate"], 0 )

> ### BirtMath.roundDown

> This function rounds a number down to a specified number of digits.

> Syntax

> Number BirtMath.roundDown( Number number, Number dec )

> Parameters

> number

> Number object. The number to round.

> dec

> Number object. The number of digits to round number down to. If you omit this argument, the function assumes 0.

> Returns

> Number object. A number rounded down to a specified number of digits.

> Examples

> The following examples shows the results that the function returns for specific numbers:

> BirtMath.roundDown( 1545.50 ) // returns 1545
> BirtMath.roundDown( 1545.56, 1 ) // returns 1545.5
> BirtMath.roundDown( 1545.23, 1 ) // returns 1545.2
> BirtMath.roundDown( 1545.50, -1 ) // returns 1540

> The following example rounds down the values in the PriceEstimate field to return an integer:

> BirtMath.roundDown( row["PriceEstimate"], 0 )

> ### BirtMath.roundUp

> This function rounds a number up to a specified number of digits.

> Syntax

> Number BirtMath.roundUp( Number number, Number dec )

> Parameters

> number

> Number object. The number to round up.

> dec

> Number object. The number of digits to round number up to. If you omit this argument, the function assumes 0.

> Returns

> Number object. A number rounded up to a specified number of digits.

> Examples

> The following examples shows the results that the function returns for specific numbers:

> BirtMath.roundUp( 1545.50 ) // returns 1546
> BirtMath.roundUp( 1545.56, 1 ) // returns 1545.6
> BirtMath.roundUp( 1545.23, 1 ) // returns 1545.3
> BirtMath.roundUp( 1545.50, -1 ) // returns 1550

> The following example rounds up the values in the PriceEstimate field to return an integer:

> BirtMath.roundUp( row["PriceEstimate"], 0 )

> ### BirtMath.safeDivide

> This function returns the result of dividing one number by another, preventing a division by zero condition.

> Syntax

> Number BirtMath.safeDivide( Number dividend, Number divisor, object ifZero )

> Parameters

> dividend

> Number object. The number to be divided.

> divisor

> Number object. The number by which dividend is divided.

> ifZero

> Object. The value to return when divisor is zero.

> Returns

> Number object. Number object. A number that results from dividing dividend by divisor.

> Examples

> The following example shows the results that the function returns for specific numbers:

> BirtMath.safeDivide( 10, 2, 0 ) // returns 5
> BirtMath.safeDivide( 10, 0, 0 ) // returns 0

> The following example returns the result of dividing values in the Revenue field by values in the Volume field. If the Volume value is 0, the function returns 0.

> BirtMath.safeDivide( row["Revenue"], row["Volume"], 0 )

> ### BirtMath.subtract

> This function returns the result of subtracting one number from another.

> Syntax

> Number BirtMath.subtract( Number n1, Number n2 )

> Parameters

> n1

> Number object. The number from which to subtract.

> n2

> Number object. The number to subtract from n1.

> Returns

> Number object. A number that results from subtracting n2 from n1.

> Example

> The following example shows the results of subtracting specific numbers:

> BirtMath.subtract( 12, 4 ) // returns 8
> BirtMath.subtract( 4, 12) // returns -8

> The following example returns the result of subtracting values in the Discount field from values in the Total field:

> BirtMath.subtract( row["Total"], row["Discount"] )

(c) Copyright Actuate Corporation 2013